# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetKafkaTopicResult',
    'AwaitableGetKafkaTopicResult',
    'get_kafka_topic',
    'get_kafka_topic_output',
]

@pulumi.output_type
class GetKafkaTopicResult:
    """
    A collection of values returned by getKafkaTopic.
    """
    def __init__(__self__, config=None, credentials=None, http_endpoint=None, id=None, kafka_cluster=None, partitions_count=None, topic_name=None):
        if config and not isinstance(config, dict):
            raise TypeError("Expected argument 'config' to be a dict")
        pulumi.set(__self__, "config", config)
        if credentials and not isinstance(credentials, dict):
            raise TypeError("Expected argument 'credentials' to be a dict")
        pulumi.set(__self__, "credentials", credentials)
        if http_endpoint and not isinstance(http_endpoint, str):
            raise TypeError("Expected argument 'http_endpoint' to be a str")
        pulumi.set(__self__, "http_endpoint", http_endpoint)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kafka_cluster and not isinstance(kafka_cluster, dict):
            raise TypeError("Expected argument 'kafka_cluster' to be a dict")
        pulumi.set(__self__, "kafka_cluster", kafka_cluster)
        if partitions_count and not isinstance(partitions_count, int):
            raise TypeError("Expected argument 'partitions_count' to be a int")
        pulumi.set(__self__, "partitions_count", partitions_count)
        if topic_name and not isinstance(topic_name, str):
            raise TypeError("Expected argument 'topic_name' to be a str")
        pulumi.set(__self__, "topic_name", topic_name)

    @property
    @pulumi.getter
    def config(self) -> Mapping[str, str]:
        """
        (Optional Map) The custom topic settings:
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def credentials(self) -> 'outputs.GetKafkaTopicCredentialsResult':
        return pulumi.get(self, "credentials")

    @property
    @pulumi.getter(name="httpEndpoint")
    def http_endpoint(self) -> str:
        return pulumi.get(self, "http_endpoint")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="kafkaCluster")
    def kafka_cluster(self) -> 'outputs.GetKafkaTopicKafkaClusterResult':
        return pulumi.get(self, "kafka_cluster")

    @property
    @pulumi.getter(name="partitionsCount")
    def partitions_count(self) -> int:
        """
        (Required Number) The number of partitions to create in the topic. Defaults to `6`.
        """
        return pulumi.get(self, "partitions_count")

    @property
    @pulumi.getter(name="topicName")
    def topic_name(self) -> str:
        return pulumi.get(self, "topic_name")


class AwaitableGetKafkaTopicResult(GetKafkaTopicResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetKafkaTopicResult(
            config=self.config,
            credentials=self.credentials,
            http_endpoint=self.http_endpoint,
            id=self.id,
            kafka_cluster=self.kafka_cluster,
            partitions_count=self.partitions_count,
            topic_name=self.topic_name)


def get_kafka_topic(credentials: Optional[pulumi.InputType['GetKafkaTopicCredentialsArgs']] = None,
                    http_endpoint: Optional[str] = None,
                    kafka_cluster: Optional[pulumi.InputType['GetKafkaTopicKafkaClusterArgs']] = None,
                    topic_name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetKafkaTopicResult:
    """
    `KafkaTopic` describes a Kafka Topic data source.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_confluentcloud as confluentcloud

    orders = confluentcloud.get_kafka_topic(kafka_cluster=confluentcloud.GetKafkaTopicKafkaClusterArgs(
            id=confluent_kafka_cluster["basic-cluster"]["id"],
        ),
        topic_name="orders",
        http_endpoint=confluent_kafka_cluster["basic-cluster"]["http_endpoint"],
        credentials=confluentcloud.GetKafkaTopicCredentialsArgs(
            key="<Kafka API Key for confluent_kafka_cluster.basic-cluster>",
            secret="<Kafka API Secret for confluent_kafka_cluster.basic-cluster>",
        ))
    pulumi.export("config", orders.config)
    ```


    :param str http_endpoint: The REST endpoint of the Kafka cluster, for example, `https://pkc-00000.us-central1.gcp.confluent.cloud:443`).
    :param str topic_name: The name of the topic, for example, `orders-1`. The topic name can be up to 255 characters in length and can contain only alphanumeric characters, hyphens, and underscores.
    """
    __args__ = dict()
    __args__['credentials'] = credentials
    __args__['httpEndpoint'] = http_endpoint
    __args__['kafkaCluster'] = kafka_cluster
    __args__['topicName'] = topic_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('confluentcloud:index/getKafkaTopic:getKafkaTopic', __args__, opts=opts, typ=GetKafkaTopicResult).value

    return AwaitableGetKafkaTopicResult(
        config=__ret__.config,
        credentials=__ret__.credentials,
        http_endpoint=__ret__.http_endpoint,
        id=__ret__.id,
        kafka_cluster=__ret__.kafka_cluster,
        partitions_count=__ret__.partitions_count,
        topic_name=__ret__.topic_name)


@_utilities.lift_output_func(get_kafka_topic)
def get_kafka_topic_output(credentials: Optional[pulumi.Input[pulumi.InputType['GetKafkaTopicCredentialsArgs']]] = None,
                           http_endpoint: Optional[pulumi.Input[str]] = None,
                           kafka_cluster: Optional[pulumi.Input[pulumi.InputType['GetKafkaTopicKafkaClusterArgs']]] = None,
                           topic_name: Optional[pulumi.Input[str]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetKafkaTopicResult]:
    """
    `KafkaTopic` describes a Kafka Topic data source.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_confluentcloud as confluentcloud

    orders = confluentcloud.get_kafka_topic(kafka_cluster=confluentcloud.GetKafkaTopicKafkaClusterArgs(
            id=confluent_kafka_cluster["basic-cluster"]["id"],
        ),
        topic_name="orders",
        http_endpoint=confluent_kafka_cluster["basic-cluster"]["http_endpoint"],
        credentials=confluentcloud.GetKafkaTopicCredentialsArgs(
            key="<Kafka API Key for confluent_kafka_cluster.basic-cluster>",
            secret="<Kafka API Secret for confluent_kafka_cluster.basic-cluster>",
        ))
    pulumi.export("config", orders.config)
    ```


    :param str http_endpoint: The REST endpoint of the Kafka cluster, for example, `https://pkc-00000.us-central1.gcp.confluent.cloud:443`).
    :param str topic_name: The name of the topic, for example, `orders-1`. The topic name can be up to 255 characters in length and can contain only alphanumeric characters, hyphens, and underscores.
    """
    ...
